diff -ruN squid-3.1.9-orig/configure.in squid-3.1.9/configure.in
--- squid-3.1.9-orig/configure.in	2010-10-25 13:35:32.000000000 +0200
+++ squid-3.1.9/configure.in	2010-10-30 01:55:25.000000000 +0200
@@ -186,6 +186,21 @@
 )
 AC_SUBST(DEFAULT_LOG_DIR)
 
+DEFAULT_SWAPDIR="$localstatedir/cache"
+AC_ARG_WITH(swapdir,
+  AS_HELP_STRING([--with-swapdir=PATH],[Default location for squid SWAP files. default: $DEFAULT_SWAPDIR]),
+ [ case $withval in
+   yes|no)
+     AC_MSG_ERROR( --with-swapdir requires a directory PATH. --with-swapdir=PATH )
+     ;;
+   *)
+     DEFAULT_SWAPDIR="$withval"
+     ;;
+   esac
+ ]
+)
+AC_SUBST(DEFAULT_SWAPDIR)
+
 DEFAULT_PIDFILE="$localstatedir/run/squid.pid"
 AC_ARG_WITH(pidfile,
   AS_HELP_STRING([--with-pidfile=PATH],[Default location for squid PID file. default: PREFIX/var/run/squid.pid]),
diff -ruN squid-3.1.9-orig/src/Makefile.am squid-3.1.9/src/Makefile.am
--- squid-3.1.9-orig/src/Makefile.am	2010-10-25 13:34:23.000000000 +0200
+++ squid-3.1.9/src/Makefile.am	2010-10-30 01:55:25.000000000 +0200
@@ -721,7 +721,7 @@
 DEFAULT_STORE_LOG       = $(DEFAULT_LOG_PREFIX)/store.log
 DEFAULT_PID_FILE        = $(DEFAULT_PIDFILE)
 DEFAULT_NETDB_FILE      = $(DEFAULT_LOG_PREFIX)/netdb.state
-DEFAULT_SWAP_DIR        = $(localstatedir)/cache
+DEFAULT_SWAP_DIR        = $(DEFAULT_SWAPDIR)
 DEFAULT_PINGER		= $(libexecdir)/`echo pinger | sed '$(transform);s/$$/$(EXEEXT)/'`
 DEFAULT_UNLINKD		= $(libexecdir)/`echo unlinkd | sed '$(transform);s/$$/$(EXEEXT)/'`
 DEFAULT_DISKD		= $(libexecdir)/`echo diskd | sed '$(transform);s/$$/$(EXEEXT)/'`
diff -ruN squid-3.1.9-orig/src/Makefile.in squid-3.1.9/src/Makefile.in
--- squid-3.1.9-orig/src/Makefile.in	2010-10-25 13:35:02.000000000 +0200
+++ squid-3.1.9/src/Makefile.in	2010-10-30 01:55:25.000000000 +0200
@@ -1982,7 +1982,7 @@
 DEFAULT_STORE_LOG = $(DEFAULT_LOG_PREFIX)/store.log
 DEFAULT_PID_FILE = $(DEFAULT_PIDFILE)
 DEFAULT_NETDB_FILE = $(DEFAULT_LOG_PREFIX)/netdb.state
-DEFAULT_SWAP_DIR = $(localstatedir)/cache
+DEFAULT_SWAP_DIR = $(DEFAULT_SWAPDIR)
 DEFAULT_PINGER = $(libexecdir)/`echo pinger | sed '$(transform);s/$$/$(EXEEXT)/'`
 DEFAULT_UNLINKD = $(libexecdir)/`echo unlinkd | sed '$(transform);s/$$/$(EXEEXT)/'`
 DEFAULT_DISKD = $(libexecdir)/`echo diskd | sed '$(transform);s/$$/$(EXEEXT)/'`

